/***************************************
  $Header: /home/amb/wwwoffle/RCS/errors.h 2.5 2000/05/14 13:51:53 amb Exp $

  WWWOFFLE - World Wide Web Offline Explorer - Version 2.6.
  Error logging header file.
  ******************/ /******************
  Written by Andrew M. Bishop

  This file Copyright 1996,97,98,2000 Andrew M. Bishop
  It may be distributed under the GNU Public License, version 2, or
  any higher version.  See section COPYING of the GNU Public license
  for conditions under which this file may be redistributed.
  ***************************************/


#ifndef ERRORS_H
#define ERRORS_H    /*+ To stop multiple inclusions. +*/

typedef enum _ErrorLevel
{
 ExtraDebug,                    /*+ For extra debugging (not in syslog). +*/
 Debug,                         /*+ For debugging (debug in syslog). +*/
 Inform,                        /*+ General information (info in syslog). +*/
 Important,                     /*+ Important information (notice in syslog). +*/
 Warning,                       /*+ A warning (warning in syslog). +*/
 Fatal                          /*+ A fatal error (err in syslog). +*/
}
ErrorLevel;

/* In errors.c */

/*+ The level of error logging +*/
extern ErrorLevel LogLevel,     /*+ in the config file for syslog and stderr. +*/
                  DebugLevel;   /*+ on the command line for stderr. +*/


void  InitErrorHandler(char *name,int syslogable,int stderrable);
char *PrintMessage(ErrorLevel errlev,const char* fmt, ...);

#endif /* ERRORS_H */
